(* 末尾でない分岐を末尾の分岐に変換 *)

open Global
open ILang

let threshold_min = 0
let threshold = ref 3

let rec g thr e =
  match e with
  | Let(x,If(c,y,z,e1,e2),e3) ->
      let e3_ = g thr e3 in
      if size e3_ <= max threshold_min thr then
        If(c,y,z,
           Let(x, g (thr/2) e1, e3_),
           Let(x, g (thr/2) e2, e3_))
      else Let(x,If(c,y,z, g (thr/2) e1, g (thr/2) e2), e3_)
  | Let(x,e1,e2) -> Let(x, g thr e1, g thr e2)
  | LetRec(x,ys,e1,e2) -> LetRec(x,ys, g thr e1, g thr e2)
  | If(c,x,y,e1,e2) -> If(c,x,y, g (thr/2) e1, g (thr/2) e2)
  | V _ | Op _ -> e

let g e = Alpha.f (g !threshold e)

let f e =
  gl_funs := List.map
      (fun x -> { x with body = Alpha.f (g x.body) })
      !gl_funs;
  Alpha.f (g e)
